/**
 * File: friends.c
 * ------------------
 * Provides a (fortunately, fairly simple, soon-to-be-obvious) fix
 * to the same code presented in broken-friends.c.
 */

#include <pthread.h>  // provides pthread_t type, thread functions
#include <stdio.h>    // provides printf, which is thread-safe

char *kFriends[] = {
    "Lana", "Tarini", "Ingrid", "Jacquelyn", "Jenny", "Grace", "Sara", "Soumaya",
    "Olivia", "Jesslyn", "Helena", "Francesca", "Yujin", "Isa", "Jiawei", "Maddie",
    "Heeba", "Sarah", "Amish", "Jennifer", "Leah", "Cheryl", "Lucy", "Jessica",
    "Fangwen", "Lepei", "Hope",
    "Imaginary friend Andy"
};

int kNumFriends = sizeof(kFriends)/sizeof(kFriends[0]) - 1; //Doesn't include Andy!

void *meetup(void *args) {
  char *name = args;
  printf("Hey, I'm %s.  This is our last CS240 class!\n", name);
  return NULL;
}

int main() {
  printf("\n%d friends meet to introduce themselves on the last day of classes.\n", kNumFriends);
  pthread_t friends[kNumFriends];
  for (int i = 0; i < kNumFriends; i++)
    pthread_create(&friends[i], NULL, meetup, (void *) kFriends[i]);
  for (int i = 0; i < kNumFriends; i++)
    pthread_join(friends[i], NULL);
  printf("Now I want to take operating systems and implement threads myself!\n\n");
  return 0;
}
